diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/block-ack-manager.cc ns-3.44/src/wifi/model/block-ack-manager.cc
--- ns-3.43/src/wifi/model/block-ack-manager.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/block-ack-manager.cc	2025-03-09 16:55:49.783372600 -0700
@@ -704,36 +1052,21 @@
 }
 
 void
-BlockAckManager::InactivityTimeout(const Mac48Address& recipient, uint8_t tid)
-{
-    NS_LOG_FUNCTION(this << recipient << +tid);
-    m_blockAckInactivityTimeout(recipient, tid, true);
-}
-
-void
-BlockAckManager::NotifyOriginatorAgreementEstablished(const Mac48Address& recipient,
-                                                      uint8_t tid,
-                                                      uint16_t startingSeq)
+BlockAckManager::InactivityTimeout(const Mac48Address& recipient,
+                                   uint8_t tid,
+                                   std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << recipient << +tid << startingSeq);
-    auto it = m_originatorAgreements.find({recipient, tid});
-    NS_ASSERT(it != m_originatorAgreements.end());
-    if (!it->second.first.IsEstablished())
-    {
-        m_originatorAgreementState(Simulator::Now(),
-                                   recipient,
-                                   tid,
-                                   OriginatorBlockAckAgreement::ESTABLISHED);
-    }
-    it->second.first.SetState(OriginatorBlockAckAgreement::ESTABLISHED);
-    it->second.first.SetStartingSequence(startingSeq);
+    NS_LOG_FUNCTION(this << recipient << tid << gcrGroupAddr.has_value());
+    m_blockAckInactivityTimeout(recipient, tid, true, gcrGroupAddr);
 }
 
 void
-BlockAckManager::NotifyOriginatorAgreementRejected(const Mac48Address& recipient, uint8_t tid)
+BlockAckManager::NotifyOriginatorAgreementRejected(const Mac48Address& recipient,
+                                                   uint8_t tid,
+                                                   std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << recipient << +tid);
-    auto it = m_originatorAgreements.find({recipient, tid});
+    NS_LOG_FUNCTION(this << recipient << tid << gcrGroupAddr.has_value());
+    auto it = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddr);
     NS_ASSERT(it != m_originatorAgreements.end());
     if (!it->second.first.IsRejected())
     {
@@ -743,14 +1076,19 @@
                                    OriginatorBlockAckAgreement::REJECTED);
     }
     it->second.first.SetState(OriginatorBlockAckAgreement::REJECTED);
-    m_unblockPackets(recipient, tid);
+    if (!gcrGroupAddr.has_value())
+    {
+        m_unblockPackets(recipient, tid);
+    }
 }
 
 void
-BlockAckManager::NotifyOriginatorAgreementNoReply(const Mac48Address& recipient, uint8_t tid)
+BlockAckManager::NotifyOriginatorAgreementNoReply(const Mac48Address& recipient,
+                                                  uint8_t tid,
+                                                  std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << recipient << +tid);
-    auto it = m_originatorAgreements.find({recipient, tid});
+    NS_LOG_FUNCTION(this << recipient << tid << gcrGroupAddr.has_value());
+    auto it = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddr);
     NS_ASSERT(it != m_originatorAgreements.end());
     if (!it->second.first.IsNoReply())
     {
@@ -760,14 +1098,19 @@
                                    OriginatorBlockAckAgreement::NO_REPLY);
     }
     it->second.first.SetState(OriginatorBlockAckAgreement::NO_REPLY);
-    m_unblockPackets(recipient, tid);
+    if (!gcrGroupAddr.has_value())
+    {
+        m_unblockPackets(recipient, tid);
+    }
 }
 
 void
-BlockAckManager::NotifyOriginatorAgreementReset(const Mac48Address& recipient, uint8_t tid)
+BlockAckManager::NotifyOriginatorAgreementReset(const Mac48Address& recipient,
+                                                uint8_t tid,
+                                                std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << recipient << +tid);
-    auto it = m_originatorAgreements.find({recipient, tid});
+    NS_LOG_FUNCTION(this << recipient << tid << gcrGroupAddr.has_value());
+    auto it = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddr);
     NS_ASSERT(it != m_originatorAgreements.end());
     if (!it->second.first.IsReset())
     {
@@ -777,6 +1120,10 @@
                                    OriginatorBlockAckAgreement::RESET);
     }
     it->second.first.SetState(OriginatorBlockAckAgreement::RESET);
+    if (gcrGroupAddr.has_value())
+    {
+        m_unblockPackets(gcrGroupAddr.value(), tid);
+    }
 }
 
 void
@@ -789,7 +1136,7 @@
 bool
 BlockAckManager::NeedBarRetransmission(uint8_t tid, const Mac48Address& recipient)
 {
-    auto it = m_originatorAgreements.find({recipient, tid});
+    auto it = GetOriginatorBaAgreement(recipient, tid);
     if (it == m_originatorAgreements.end() || !it->second.first.IsEstablished())
     {
         // If the inactivity timer has expired, QosTxop::SendDelbaFrame has been called and
@@ -797,7 +1144,7 @@
         return false;
     }
 
-    Time now = Simulator::Now();
+    const auto now = Simulator::Now();
 
     // A BAR needs to be retransmitted if there is at least a non-expired in flight MPDU
     for (auto mpduIt = it->second.second.begin(); mpduIt != it->second.second.end();)
@@ -815,8 +1162,18 @@
     return false;
 }
 
+bool
+BlockAckManager::NeedGcrBarRetransmission(const Mac48Address& gcrGroupAddress,
+                                          const Mac48Address& recipient,
+                                          uint8_t tid) const
+{
+    const auto it = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddress);
+    return (it != m_originatorAgreements.cend() && it->second.first.IsEstablished());
+}
+
 void
-BlockAckManager::SetBlockAckInactivityCallback(Callback<void, Mac48Address, uint8_t, bool> callback)
+BlockAckManager::SetBlockAckInactivityCallback(
+    Callback<void, Mac48Address, uint8_t, bool, std::optional<Mac48Address>> callback)
 {
     NS_LOG_FUNCTION(this << &callback);
     m_blockAckInactivityTimeout = callback;
@@ -857,25 +1214,70 @@
 uint16_t
 BlockAckManager::GetRecipientBufferSize(const Mac48Address& recipient, uint8_t tid) const
 {
-    uint16_t size = 0;
-    auto it = m_originatorAgreements.find({recipient, tid});
-    if (it != m_originatorAgreements.end())
-    {
-        size = it->second.first.GetBufferSize();
-    }
-    return size;
+    const auto it = GetOriginatorBaAgreement(recipient, tid);
+    return (it != m_originatorAgreements.cend()) ? it->second.first.GetBufferSize() : 0;
 }
 
 uint16_t
 BlockAckManager::GetOriginatorStartingSequence(const Mac48Address& recipient, uint8_t tid) const
 {
+    const auto it = GetOriginatorBaAgreement(recipient, tid);
+    return (it != m_originatorAgreements.cend()) ? it->second.first.GetStartingSequence() : 0;
+}
+
+uint16_t
+BlockAckManager::GetGcrStartingSequence(const Mac48Address& groupAddress, uint8_t tid) const
+{
     uint16_t seqNum = 0;
-    auto it = m_originatorAgreements.find({recipient, tid});
-    if (it != m_originatorAgreements.end())
+    for (const auto& [key, pair] : m_originatorAgreements)
     {
-        seqNum = it->second.first.GetStartingSequence();
+        if (key.second != tid)
+        {
+            continue;
+        }
+        if (pair.first.GetGcrGroupAddress() == groupAddress)
+        {
+            seqNum = pair.first.GetStartingSequence();
+            break;
+        }
     }
     return seqNum;
 }
 
+uint16_t
+BlockAckManager::GetGcrBufferSize(const Mac48Address& groupAddress, uint8_t tid) const
+{
+    /* The AP shall maintain a set of the most recently received values of the
+       Buffer Size subfield from the Block Ack Parameter Set field in the ADDBA
+       Response frame received from each member of a specific group address.
+       The minimum of that set of values is defined to be the GCR buffer size
+       for that group address. */
+    uint16_t gcrBufferSize = std::numeric_limits<uint16_t>::max();
+    for (const auto& [key, pair] : m_originatorAgreements)
+    {
+        if ((key.second == tid) && (pair.first.GetGcrGroupAddress() == groupAddress))
+        {
+            gcrBufferSize = std::min(pair.first.GetBufferSize(), gcrBufferSize);
+        }
+    }
+    return gcrBufferSize;
+}
+
+bool
+BlockAckManager::IsGcrAgreementEstablished(const Mac48Address& gcrGroupAddress,
+                                           uint8_t tid,
+                                           const GcrManager::GcrMembers& members) const
+{
+    NS_ASSERT(!members.empty());
+    for (const auto& member : members)
+    {
+        if (const auto agreement = GetAgreementAsOriginator(member, tid, gcrGroupAddress);
+            !agreement || !agreement->get().IsEstablished())
+        {
+            return false;
+        }
+    }
+    return true;
+}
+
 } // namespace ns3
